/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreValuelistPersonRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreValuelistPerson extends TableImpl<VCoreValuelistPersonRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_valuelist_person</code>
     */
    public static final VCoreValuelistPerson V_CORE_VALUELIST_PERSON = new VCoreValuelistPerson();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreValuelistPersonRecord> getRecordType() {
        return VCoreValuelistPersonRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_valuelist_person.valuelist</code>.
     */
    public final TableField<VCoreValuelistPersonRecord, Integer> VALUELIST = createField(DSL.name("valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_person.order</code>.
     */
    public final TableField<VCoreValuelistPersonRecord, String> ORDER = createField(DSL.name("order"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_person.usnr</code>.
     */
    public final TableField<VCoreValuelistPersonRecord, Integer> USNR = createField(DSL.name("usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_person.username</code>.
     */
    public final TableField<VCoreValuelistPersonRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_person.forename</code>.
     */
    public final TableField<VCoreValuelistPersonRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_valuelist_person.surname</code>.
     */
    public final TableField<VCoreValuelistPersonRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    private VCoreValuelistPerson(Name alias, Table<VCoreValuelistPersonRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreValuelistPerson(Name alias, Table<VCoreValuelistPersonRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_valuelist_person" as  SELECT sub.valuelist,
         (sub.x).key AS "order",
         (((sub.x).value)::text)::integer AS usnr,
         t_core_person.username,
         t_core_person.forename,
         t_core_person.surname
        FROM (( SELECT t_core_valuelist.valuelist,
                 jsonb_each(t_core_valuelist."values") AS x
                FROM common_dd.t_core_valuelist
               WHERE (t_core_valuelist.fk_valuetype = 3)) sub
          LEFT JOIN common_dd.t_core_person ON (((((sub.x).value)::text)::integer = t_core_person.usnr)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_person</code> table
     * reference
     */
    public VCoreValuelistPerson(String alias) {
        this(DSL.name(alias), V_CORE_VALUELIST_PERSON);
    }

    /**
     * Create an aliased <code>common_dd.v_core_valuelist_person</code> table
     * reference
     */
    public VCoreValuelistPerson(Name alias) {
        this(alias, V_CORE_VALUELIST_PERSON);
    }

    /**
     * Create a <code>common_dd.v_core_valuelist_person</code> table reference
     */
    public VCoreValuelistPerson() {
        this(DSL.name("v_core_valuelist_person"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreValuelistPerson as(String alias) {
        return new VCoreValuelistPerson(DSL.name(alias), this);
    }

    @Override
    public VCoreValuelistPerson as(Name alias) {
        return new VCoreValuelistPerson(alias, this);
    }

    @Override
    public VCoreValuelistPerson as(Table<?> alias) {
        return new VCoreValuelistPerson(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistPerson rename(String name) {
        return new VCoreValuelistPerson(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistPerson rename(Name name) {
        return new VCoreValuelistPerson(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreValuelistPerson rename(Table<?> name) {
        return new VCoreValuelistPerson(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPerson where(Condition condition) {
        return new VCoreValuelistPerson(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPerson where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPerson where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPerson where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPerson where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPerson where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPerson where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreValuelistPerson where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPerson whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreValuelistPerson whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
